SystemOrganization addCategory: #'Xenon-Tests'!

Object subclass: #XeFunctionWhenItHasManyReturnTypeScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeFunctionWhenItHasManyReturnTypeScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
	<returnType: #int>
	<returnType: #void>
! !

Object subclass: #XeFunctionWhenReturnTypeIsDefaultScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeFunctionWhenReturnTypeIsDefaultScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
! !

Object subclass: #XeFunctionWhenReturnTypeIsIntegerScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeFunctionWhenReturnTypeIsIntegerScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
	<returnType: #int>
! !

Object subclass: #XeFunctionWhenReturnTypeIsUnknownScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeFunctionWhenReturnTypeIsUnknownScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
	<returnType: #unknown>
! !

Object subclass: #XeFunctionWithOneArgumentScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeFunctionWithOneArgumentScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/2/2012 01:57'!
foo: x
	<returnType: #int>
! !

TestCase subclass: #XeTranslateFunctionTest
	instanceVariableNames: 'xenon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeTranslateFunctionTest methodsFor: 'running' stamp: 'BernardoContreras 3/15/2012 23:04'!
setUp
	xenon := Xenon new! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 4/2/2012 01:55'!
testTranslateFunctionWhenItHasManyReturnTypes
	self should: [xenon translate: XeFunctionWhenItHasManyReturnTypeScenario] raise: XeTooManyReturnTypesError
! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 4/2/2012 02:40'!
testTranslateFunctionWhenReturnTypeIsDefault
	| actual expected |
	actual := xenon translate: XeFunctionWhenReturnTypeIsDefaultScenario.
	expected := 'sqInt foo(){
}'.
	self assert: expected equals: actual! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 4/2/2012 02:40'!
testTranslateFunctionWhenReturnTypeIsInteger
	| actual expected |
	actual := xenon translate: XeFunctionWhenReturnTypeIsIntegerScenario.
	expected := 'int foo(){
}'.
	self assert: expected equals: actual! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 4/2/2012 01:56'!
testTranslateFunctionWhenReturnTypeIsUnknown
	
	self should: [xenon translate: XeFunctionWhenReturnTypeIsUnknownScenario] raise: XeTypeNotFoundError
! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 4/2/2012 02:38'!
testTranslateFunctionWithOneArgument
	| actual expected |
	actual := xenon translate: XeFunctionWithOneArgumentScenario.
	expected := 'int foo(sqInt x){
}'.
	self assert: expected equals: actual! !
